; created 10/07/90
; updated 02/03/92
;       revised 02/22/93
;               SETKBD to use BYVAL

;============================================================================
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================
;RM82TS8,16,24,32,40

DOSSEG
.MODEL MEDIUM, BASIC

BIOSRAM SEGMENT AT 0            ;make ASSUMEs more readable
BIOSRAM ENDS

ROM SEGMENT AT 0FFFFh
ROM ENDS


.CODE

;===========================================================================
; DECLARE SUB GETKBD (Insert%, Caps%, NumL%, Scrolk%)
; Tests keyboard state
;       False (0)   = keyboard element off
;       Not False   = keyboard element On
;===========================================================================

EVEN
GETKBD PROC FAR BASIC INSERT:WORD, CAPS:WORD, NUML:WORD, SCROLK:WORD
	Xor            AX,AX         ;select BIOS RAM
	Mov            ES,AX         ;put segment address in ES
	Assume         ES:BIOSRAM
	Mov            AL,ES:[417h]  ;read 0040:0017 kbd shift status
	Xor            CX,CX         ;clear CX
	Test           AL,80h        ;Test left most bit of 0040:0017h
	JZ             @F
				     ;return a -1
	Dec            CX            ;make CX = -1
 @@:
	Mov            BX,INSERT     ;get Insert address
	Mov            [BX],CX       ;store in Insert%
	Xor            CX,CX         ;clear CX
	Test           AL,40h        ;Test 2d left bit of 0040:0017h
	JZ             @F
	Dec            CX            ;make CX = -1
 @@:
	Mov            BX,CAPS       ;get Capslock address
	Mov            [BX],CX       ;
	Xor            CX,CX
	Test           AL,20h        ;Test 3d left bit of 0040:0017h
	JZ             @F
	Dec            CX
 @@:
	Mov            BX,NUML       ;get Numlock address
	Mov            [BX],CX
	Xor            CX,CX         ;clear CX
	Test           AL,10h        ;Test 4th left bit of 0040:0017h
	JZ             @F
	Dec            CX            ;make CX = -1
 @@:
	Mov            BX,SCROLK     ;get Scrollock address
	Mov            [BX],CX       ;store result in ScrollLock%
	Ret
GETKBD  ENDP

;===========================================================================
; DECLARE SUB SETKBD (BYVAL Insert%, BYVAL Caps%, BYVAL NumL%, BYVAL Scrolk%)
; Toggle keyboard state according to input
;       False (0)   = keyboard element off
;       Not False   = keyboard element On
;===========================================================================

EVEN
SETKBD PROC FAR INSERT:WORD, CAPS:WORD, NUML:WORD, SCROLK:WORD
	Xor            AX,AX                ;set Bios Ram segment
	Mov            ES,AX                ;Set ES to the BIOS area of ram
	ASSUME         ES:BIOSRAM           ;tell MASM
	Mov            AL,ES:[417h]         ;get KeyBoard Bios status byte
	And            AL,1111b             ;clear all but lower 4 bits
	Mov            BX,INSERT            ;get insert word (note BYVAL)
;Test Insert for clear
	Or             BX,BX                ;is is zero
	JZ             @f                   ;yes so jump ahead
	OR             AL,80h               ;no so set the bit
@@:
;Test Capslock for clear
	Mov            BX,CAPS              ;get capslock word (note BYVAL)
	Or             BX,BX                ;is it zero?
	JZ             @f                   ;yes so jump ahead
	OR             AL,40h               ;no so set the bit
@@:
;Test Numlock for clear
	Mov            BX,NUML              ;get numlock word (note BYVAL)
	Or             BX,BX                ;is it zero?
	JZ             @f                   ;yes so jump ahead
	OR             AL,20h               ;no so set the bit
@@:
;Test Scrollock for clear
	Mov            BX,SCROLK            ;get scrolllock word (note BYVAL)
	Or             BX,BX                ;is it zero?
	JZ             @f                   ;yes so jump ahead
	OR             AL,10h               ;no so set the bit
@@:
;reset BIOS ram area with the change
	Mov           ES:[417h],AL          ;reset Bios ram
	Ret
SETKBD  ENDP

;===========================================================================
; DECLARE FUNCTION YESNO% ()
; Returns:
;	-1 if Y key pressed
;	 0 if N key pressed
; Clears keyboard of keys, then waits for a key, if wrong key pressed
; program beeps
;===========================================================================

EVEN
YESNO PROC FAR
Wait4key:
	Mov 	AH,01			; see if buffer empty
	Int	16h
	JZ	@f			; buffer empty if ZF set
	Xor	AH,AH			; if buffer not empty read keystroke
	Int	16h
	Jmp	Short Wait4key
@@:
	Xor	AH,AH                   ; if no key waiting
	Int	16h                     ; program is in an infinite loop
	Or      AL,AL                   ; test for extended key
	JZ	BadKey			; report got bad key
	Xor	BX,BX			; assume will get "N" key
	CMP	AH,31h			; test for "N" scan code
	JE      Goodkey                 ; found, so end
        Cmp	AH,15h                  ; test for "Y" scan code
	JE	Ykey                    ; if yes then exit
BadKey:                                 ; else report error
	Xor	BH,BH			; select video page 0
	Mov     AX,0E07h                ; Write ASCII 7 character
	Push    BP                      ; prevent errors with video bios
	Int     10h                     ; (bell) to console (BEEP)
	Pop     BP                      ; restore BP
	Jmp     Short   Wait4key        ; got the wrong key so beep
Ykey:
	Mov	BX,-1                   ; put -1 in BX
Goodkey:
	Mov	AX,BX			; get value back from BX
	Ret                             ; back to basic
YESNO	ENDP
END

